#include  <stdio.h>
#include  <stdlib.h>
#include  <stdint.h>
#include  <string.h>
#include  <unistd.h>
#include  <sys/time.h>
#include  <math.h>
#include  <glob.h>

#include  <floatimg.h>
#include  <tthimage.h>

#include  "operator.h"
#include  "picfx.h"

int		verbosity = 0;

#define		OPERATION	2

/* ------------------------------------------------------------------------ */

int boucle_du_rafaleur(char *globber, char *destdir, int pa, int pb)
{
int		idx, foo;
glob_t		globbuf;
char		*iname, tganame[600];

fprintf(stderr, "%s: opcode = %d\n", __func__, pa);

idx = 0;
memset(&globbuf, 0, sizeof(glob_t));
foo = glob(globber, 0, NULL, &globbuf);

switch (foo) {
	case GLOB_NOSPACE:
		fprintf(stderr, "%s: glob run out of memory\n", __func__);
		break;
	case GLOB_ABORTED:
		fprintf(stderr, "%s: glob read error\n", __func__);
		break;
	case GLOB_NOMATCH:
		fprintf(stderr, "%s: glob found no matches\n", __func__);
		break;
	}

if (0 == globbuf.gl_pathc) {
	fprintf(stderr, "%s: no file found, aborting\n", __func__);
	return 7;
	}
else	{
	fprintf(stderr, "%ld file found for '%s'\n", globbuf.gl_pathc, globber);
	}

for (idx=0; idx<globbuf.gl_pathc; idx++) {

	iname = globbuf.gl_pathv[idx];		/* alias of filename */
	sprintf(tganame, "%s/%05d.tga", destdir, idx);

	fprintf(stderr, "%6d / %6ld\r", idx, globbuf.gl_pathc);

	foo = operation_fname(iname, tganame, pa, pb, idx);
	if (foo) {
		fprintf(stderr, "%s: operation give a %d score\n", __func__, foo);
		return 7;
		}
	fprintf(stderr, ".\n");
	}

globfree(&globbuf);		/* cleanup */

return 0;
}
/* ------------------------------------------------------------------------ */
int main(int argc, char *argv[])
{
int			foo, opcode;
char			outdir[500];

fprintf(stderr, "---------[  %s  %d  ]--------\n", argv[0], getpid());

if (2 != argc) {
	fprintf(stderr, "%s need a numeric opcode\n", argv[0]);
	exit(1);
	}
foo = sscanf(argv[1], "%d", &opcode);
if (1 != foo) {
	fprintf(stderr, "err parsing '%s'\n", argv[1]);
	exit(1);
	}
init_the_bizness(argv[0]);

sprintf(outdir, "p8/%03d/", opcode);
fprintf(stderr, "outdir = '%s'\n", outdir);

foo = boucle_du_rafaleur("capture/?????.fimg", outdir, opcode, 0);
fprintf(stderr, "boucle rafale -> %d\n", foo);

return foo;
}
/* ------------------------------------------------------------------------ */
